#include <strings.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

#include "common.h"

struct dvb_host *parse(char *urlpart, char *defport)
{
	static struct dvb_host *dvbhost = NULL;
	char *pos;

	if (!dvbhost) {
		if (!(dvbhost = malloc(sizeof(struct dvb_host)))) {
			perror("malloc");
			exit(EXIT_FAILURE);
		}
	}

	bzero(dvbhost, sizeof(struct dvb_host));
	
	if (!(dvbhost->hostname = strdup(urlpart))) {
		perror("strdup");
		exit(EXIT_FAILURE);
	}

	/* Unneded, but better readablity: */
	dvbhost->location = NULL;
	dvbhost->port = NULL;

	pos = dvbhost->hostname;

	while(*pos != '\0' && *pos != ':' && *pos != '/')
		pos++;

	if (*pos == '/')
		dvbhost->location = pos + 1;

	if (*pos == ':')
		dvbhost->port = pos + 1;

	*pos = 0;

	if (dvbhost->port) {
		pos++;

		while(*pos != '\0' && *pos != '/')
			pos ++;

		if(*pos == '/')
			dvbhost->location = pos + 1;

		*pos = 0;
	}

	if (!dvbhost->port)
		dvbhost->port = strdup(defport);

	if (!dvbhost->location)
		if(!(dvbhost->location = strdup(""))) {
			perror("strdup");
			exit(EXIT_FAILURE);
		}

	return dvbhost;
}

int resolve(struct dvb_host *dvbhost, struct sockaddr_in *server)
{
	struct addrinfo *s_addrinfo, addrhints;
	int res;

	bzero(&addrhints, sizeof(struct addrinfo));
	addrhints.ai_family = PF_INET;
	addrhints.ai_socktype = dvbhost->socktype;

	if ((res = getaddrinfo(dvbhost->hostname, dvbhost->port, &addrhints, &s_addrinfo))) {
		fprintf(stderr,"getaddrinfo: %s\n",gai_strerror(res));
		return -1;
	}

	bzero(server, sizeof(struct sockaddr_in));
	server->sin_family = AF_INET;
	server->sin_addr.s_addr = ((struct sockaddr_in*)(s_addrinfo->ai_addr))->sin_addr.s_addr;
	server->sin_port = ((struct sockaddr_in*)(s_addrinfo->ai_addr))->sin_port;

	freeaddrinfo(s_addrinfo);

	return 0;
}

